-- Tatsuru

-- Make an object move towards another.
local Lib = FFZLib
Lib["HomingChase"] = function(mo, target, speed, xoffs, yoffs, zoffs, thrust)
	xoffs = $ or 0
	yoffs = $ or 0
	zoffs = $ or 0
	
	local xthrust = thrust and xoffs or 0
	local ythrust = thrust and yoffs or 0
	local zthrust = thrust and zoffs or 0
	
	local newx = target.x + xoffs
	local newy = target.y + yoffs
	local newz = target.z + zoffs
	local dist = R_PointToDist2(0, 0, R_PointToDist2(mo.x, mo.y, newx, newy), newz - mo.z)
	
	if speed < dist
		mo.momx = FixedMul(FixedDiv(newx - mo.x, dist), speed) + xthrust
		mo.momy = FixedMul(FixedDiv(newy - mo.y, dist), speed) + ythrust
		mo.momz = FixedMul(FixedDiv(newz - mo.z, dist), speed) + zthrust
	elseif speed > dist
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		P_TeleportMove(mo, newx, newy, newz)
		return true
	end
end