addHook("MobjThinker", function(mo)
	if not mo then return end
	if not mo.valid then return end
	if not (mapheaderinfo[gamemap].lvlttl == "Foliage Furnace") then return end
	if mo.state == S_STEAM6 then mo.state = S_STEAM1 end
	mo.flags = $ & ~MF_NOCLIP
	mo.flags = $ | MF_SOLID
end, MT_STEAM)

addHook("MobjCollide", function(mo, pmo)
	if not mo then return end
	if not mo.valid then return end
	if not pmo then return end
	if not pmo.valid then return end
	if not pmo.player then return end
	if not pmo.player.valid then return end
	if not (mapheaderinfo[gamemap].lvlttl == "Foliage Furnace") then return end
	
	local p = pmo.player // will be nil if not a player
	local zdist // distance between bottoms
	local speed = mo.info.mass // conveniently, both fans and gas jets use this for the vertical thrust
	local flipval = P_MobjFlip(mo) // virtually everything here centers around the thruster's gravity, not the object's!

	if (p and pmo.state == pmo.info.painstate) // can't use fans and gas jets when player is in pain!
		return
	end
	
	// is object's top below thruster's position? if not, calculate distance between their bottoms
	if (mo.eflags & MFE_VERTICALFLIP)
		if (pmo.z > mo.z + mo.height)
			return
		end
		zdist = (mo.z + mo.height) - (pmo.z + pmo.height)
	else
		if (pmo.z + pmo.height < mo.z)
			return
		end
		zdist = pmo.z - mo.z
	end
	
	
	
	if (zdist > FixedMul(16*FRACUNIT, mo.scale))
		return
	end
	if not (mo.state == S_STEAM1) // Only when it bursts
		return
	end

	pmo.eflags = $ | MFE_SPRUNG
	pmo.momz = flipval*FixedMul(speed, FixedSqrt(FixedMul(mo.scale, pmo.scale))) // scale the speed with both objects' scales, just like with springs!

	if (pmo.player)
		P_ResetPlayer(pmo.player)
		if not (pmo.player.panim == PA_FALL)
			pmo.state = S_PLAY_FALL
		end
	end
end, MT_STEAM)